
fbItemPrice = {}
fbItemPrice.items = {}
fbItemPrice.items = fbDkp
fbItemPrice.frame = CreateFrame("Frame","ItemKuhPriceFrame")
fbItemPrice.frame:RegisterEvent("CHAT_MSG_WHISPER");-- Register our event
fbItemPrice.frame:RegisterEvent("CHAT_MSG_ADDON")
fbItemPrice.frame:RegisterEvent("ADDON_LOADED")


local fbitem_prefix_request = "fbitem_request"
local fbitem_prefix_response = "fbitem_response"
local fbitem_request_master = "Gazoz"

function fbItemPrice.initGuideFrame()
    C_ChatInfo.RegisterAddonMessagePrefix(fbitem_prefix_request)
    C_ChatInfo.RegisterAddonMessagePrefix(fbitem_prefix_response)
end

function fbItemPrice.broadcastDKPRequest(player, konto, post)
    -- print('send request to ' .. fbitem_request_master)
    if(UnitExists("Procter")) then
        -- fallback Procter
        fbitem_request_master = "Procter"
    end
    if(UnitExists("Kuhlager")) then
        -- fallback Kuhlager
        fbitem_request_master = "Kuhlager"
    end
    if(UnitExists("Sugoroku")) then
        -- fallback Sugoroku
        fbitem_request_master = "Sugoroku"
    end
    if(UnitExists("Gazoz")) then
         fbitem_request_master = "Gazoz"
    end

    success = C_ChatInfo.SendAddonMessage(fbitem_prefix_request, player .. "|" .. konto .. "|" .. post, "WHISPER", fbitem_request_master)
end

function fbItemPrice.broadcastDKPResponse(player, konto, points, post, success)
    -- print('send response to ' .. player)
    local success_str = "false"
    if (success == true) then
        success_str = "true"
    end
    success = C_ChatInfo.SendAddonMessage(fbitem_prefix_response, player .. "|" .. konto .. "|" .. points .. "|" .. post .. "|" .. success_str, "WHISPER", player)
end



local find = string.find
local format = string.format


function fbItemPrice.MyAddonCommands(msg, editbox)
    if msg ~= nil then
        local my_name = UnitName(UnitName("player"));
        local method, konto = strsplit(" ", msg, 2);
        if method == "get" then
            fbItemPrice.broadcastDKPRequest(my_name, konto, "get")
        end
        if method == "post" then
            fbItemPrice.broadcastDKPRequest(my_name, konto, "post")
        end
    end
end


SLASH_FBITEMPRICE1 = '/fbdkp'

SlashCmdList["FBITEMPRICE"] = fbItemPrice.MyAddonCommands   -- add /hiw and /hellow to command list


fbItemPrice.frame:SetScript("OnEvent",function(self, event, arg1, arg2, arg3, arg4, arg5, ...)-- OnEvent handler receives event triggers

    if event == "ADDON_LOADED" and arg1 == "fbItemPrice" then
		fbItemPrice.initGuideFrame()
    end

    if event == "CHAT_MSG_ADDON" then
        -- "prefix", "text", "channel", "sender", "target", zoneChannelID, localID, "name", instanceID
        if (arg1 == fbitem_prefix_request) then
            local my_name = UnitName(UnitName("player"));
            local sender = arg4
            local target = arg5
            local player, konto, post = strsplit("|", arg2, 3);
            -- print('sender: ' .. sender .. ', target: ' .. target .. ', my_name: ' .. my_name)
            -- send dkp infos back to request sender
            local points, success, real_konto = fbItemPrice.getDkpForPlayerAndKonto(player, konto)
            if (success == true) then
                fbItemPrice.broadcastDKPResponse(target, real_konto, points, post, success)
            else
                fbItemPrice.broadcastDKPResponse(target, konto, points, post, success)
            end

        end
        if (arg1 == fbitem_prefix_response) then
            local my_name = UnitName(UnitName("player"));
            -- local sender = arg4
            -- local target = arg5
           fbItemPrice.parseResponseMessage(arg2)
        end

    end
end);


function fbItemPrice.parseResponseMessage(message)
    if (message ~= nil) then
        local player, konto, points, post, success_str = strsplit("|", message, 5);
        -- print(my_name)
        if (player == UnitName("player")) then
            -- print(arg2)
            --print(player .. "|" .. konto .. "|" .. points .. "|" .. post)
            if (success_str == "true") then
                if (post == "post") then
                    SendChatMessage(points .. " " .. konto, "RAID");
                else
                    print(points .. " " .. konto);
                end
            else
                print("error: " .. message);
            end
        end
    end
end

function fbItemPrice.getDkpForPlayerAndKonto(player, konto)

    if gdkp == nil then
        return "table_found_not_found", false, nil
    else
        if gdkp.players == nil then
            return "table_not_loaded", false, nil
        else
            if gdkp.players[player] == nil then
               return "player_" .. player .. "_not_found", false, nil
            else
                local real_konto = fbItemPrice.getKonto(konto)
                if (real_konto == nil) then
                    return "konto_" .. konto .. "_not_found", false, nil
                else
                    if gdkp.players[player][real_konto .. "_current"] == nil then
                        return "konto_" .. real_konto .. "_for_player_" .. player .. "_not_found", false, nil
                    else
                        return gdkp.players[player][real_konto .. "_current"], true, real_konto
                    end
                end
            end
        end
    end
end

function fbItemPrice.getKonto(str)

    if (multiTable == nil) then
        return nil
    else
        local real_konto = nil
        for i=1, getn(multiTable),1 do
            table.foreach(multiTable[i], function(k,v)
                if (string.lower(str) == string.lower(v["name"])) then
                    real_konto = v["name"]
                end
            end)
        end;
        return real_konto
    end
end


local function GameTooltip_OnTooltipSetItem(tooltip)
	local itemName, itemLink = tooltip:GetItem()
	if not itemName or not itemLink then return; end
	
	local _, _, _, _, _, itemType = GetItemInfo(itemLink)


	local _, itemId, enchantId, jewelId1, jewelId2, jewelId3, jewelId4, suffixId, uniqueId,
		  linkLevel, specializationID, reforgeId, unknown1, unknown2 = strsplit(":", itemLink)

    --print(itemType)
	if itemType ~= "Armor" and itemType ~= "Weapon" and itemType ~= "Rüstung" and itemType ~= "Waffe"
	  and itemType ~= "Quest"
	   and itemType ~= "Miscellaneous" then
		return
	end

	--for itemSet, note in pairs(itemSets) do
		--if find(itemName, format("^%s", itemSet)) then
			--tooltip:AddLine(note)
		--end
	--end

	itemId = tonumber(itemId)
	
	if fbItemPrice.items == nil then
		tooltip:AddLine("nope")
	else
		if fbItemPrice.items[itemId] then
			--tooltip:AddLine(fbItemPrice.items[itemId][1]["name"])
			--tooltip:AddLine(fbItemPrice.items[itemId][1]["value"])
			--tooltip:AddLine(table.getn(fbItemPrice.items[itemId]))
			
			local t = fbItemPrice.items[itemId]
			
			tooltip:AddLine("|cFF00FF00---------------DKP Preise---------------|r")
			
			for p=1,table.getn(t) do
				local row = t[p]
				
				local value = "|cFFA330C9" ..  row["value"] .. "|r"
				
				if (row["note"] ~= "") then
					tooltip:AddLine(row["role"] .. ": " .. value .. " (" .. row["note"] .. ")")
				else
					tooltip:AddLine(row["role"] .. ": " .. value)
				end
				--tooltip:AddLine(row["name"])
				--tooltip:AddLine(row["value"])
				--tooltip:AddLine(row["note"])
			end
			tooltip:AddLine("|cFF00FF00---------------------------------------------|r")
		end
		
		--print("test")
		--print(fbItemPrice.tablelength(fbItemPrice.items));
		local tokenList = {}
		for _, armyName in pairs(fbItemPrice.items) do
            for p=1,table.getn(armyName) do
                local row = armyName[p]
                --print(itemId)
                if (row["token"] ~= "" and tonumber(row["token"]) == itemId) then
                    local value = "|cFFA330C9" ..  row["value"] .. "|r"
                    local name = "|cFFA330C9" ..  row["name"] .. "|r"
                    if (row["note"] ~= "") then
                        table.insert(tokenList, name .. " |cFF00FF00for|r " .. row["role"] .. ": " .. value.. " (" .. row["note"] .. ")")
                    else
                        table.insert(tokenList, name .. " |cFF00FF00for|r " .. row["role"] .. ": " .. value)
                    end

                end
                --tooltip:AddLine(row["name"])
                --tooltip:AddLine(row["value"])
                --tooltip:AddLine(row["note"])
            end
        end

        if (table.getn(tokenList) > 0) then
             tooltip:AddLine("----------------------------------")
             for p=1,table.getn(tokenList) do
                tooltip:AddLine(tokenList[p])
             end
        end
	end


end

function fbItemPrice.tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

GameTooltip:HookScript("OnTooltipSetItem", GameTooltip_OnTooltipSetItem)
